Form STRUCT
    hWnd            DWORD   ?
    hDC             DWORD   ?
    lpszClass       DWORD   ?
    lpszCaption     DWORD   ?
    hIcon           DWORD   ?
    hCursor         DWORD   ?
    dwLeft          DWORD   ?
    dwTop           DWORD   ?
    dwWidth         DWORD   ?
    dwHeight        DWORD   ?
    dwJumpTable     DWORD   ?
Form ENDS
    
    MakeWindowNormal        PROTO   :DWORD
    MakeWindowMDI           PROTO   :DWORD
    MakeWindowMDIChild      PROTO   :DWORD, :DWORD, :DWORD
    __makewin               PROTO   :DWORD, :DWORD
    __makewin2              PROTO   :DWORD, :DWORD, :DWORD, :DWORD
    __wndProc               PROTO   :DWORD, :DWORD, :DWORD, :DWORD
    __wndProc2              PROTO   :DWORD, :DWORD, :DWORD, :DWORD
    
    UnloadWindow            PROTO   :DWORD

    .const
        szDefaultClass      BYTE    "WINDOW_CLASS",0
        szNull              BYTE    0
    .data
        WindowsMade         DWORD   -1
    .data?
        hWndTable           DWORD   512 DUP (?)     ;First and then each second contains hWnd, followed by address of jump table
        lpDestroyCallback   DWORD   ?
    .code

; 

IFNDEF <mmov>
    mmov MACRO dest, src, midreg
        IFB <midreg>
            mov     edx, src
            mov     dest, edx
        ELSE
            mov     midreg, src
            mov     dest, midreg
        ENDIF
    ENDM
ENDIF


; 
; ====================================
; 
MakeWindowNormal PROC lpForm:DWORD
    invoke  __makewin, lpForm, COLOR_BTNFACE+1
    ret
MakeWindowNormal ENDP

MakeWindowMDI PROC lpForm:DWORD
    invoke  __makewin, lpForm, COLOR_APPWORKSPACE+1
    ret
MakeWindowMDI ENDP

MakeWindowMDIChild PROC lpForm:DWORD, hParent:DWORD, lpProc:DWORD
    invoke  __makewin2, lpForm, COLOR_BTNFACE+1, hParent, lpProc
    ret
MakeWindowMDIChild ENDP

; -------------------------------------------------------------------------

__makewin PROC USES ebx lpForm:DWORD, dwBackColor:DWORD
    LOCAL hInst:DWORD
    LOCAL wc:WNDCLASSEX
    
    invoke  GetModuleHandle, NULL
    mov     hInst, eax
    
    mov     ebx, lpForm
    ASSUME  ebx:PTR Form
    
    cmp     [ebx].hCursor, 0
    jne     @F
    invoke  LoadCursor, NULL, IDC_ARROW
    mov     [ebx].hCursor, eax

@@: 
    cmp     [ebx].lpszClass, 0
    jne     @F
    mov     [ebx].lpszClass, OFFSET szDefaultClass

@@: 
    cmp     [ebx].lpszCaption, 0
    jne     @F
    mov     [ebx].lpszClass, OFFSET szNull
    
@@: 
    mov     wc.cbSize,          sizeof WNDCLASSEX
    mov     wc.style,           CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
    mmov    wc.lpfnWndProc,     OFFSET __wndProc
    mov     wc.cbClsExtra,      NULL
    mov     wc.cbWndExtra,      NULL
    mmov    wc.hInstance,       hInst
    mmov    wc.hbrBackground,   dwBackColor
    mov     wc.lpszMenuName,    NULL
    mmov    wc.lpszClassName,   [ebx].lpszClass
    mmov    wc.hIcon,           [ebx].hIcon
    mmov    wc.hCursor,         [ebx].hCursor
    mmov    wc.hIconSm,         [ebx].hIcon

    invoke  RegisterClassEx, ADDR wc
    or      eax, eax
    jz      ErrorHandler
    
    invoke  CreateWindowEx, WS_EX_LEFT,
                            [ebx].lpszClass,
                            [ebx].lpszCaption,
                            WS_OVERLAPPEDWINDOW,
                            [ebx].dwLeft,[ebx].dwTop,[ebx].dwWidth,[ebx].dwHeight,
                            NULL,NULL,
                            hInst,NULL
    or      eax, eax
    jz      ErrorHandler
    
    mov     [ebx].hWnd, eax
    invoke  GetDC, eax
    mov     [ebx].hDC, eax
    
    lea     edi, hWndTable
    inc     WindowsMade
    mov     ecx, WindowsMade
    lea     edi, [edi+ecx*8]
    mmov    DWORD PTR [edi], [ebx].hWnd
    
    mov     [ebx].dwJumpTable, MAlloc(1024*4)
    mov     DWORD PTR [edi+4], eax
    mov     edi, [ebx].dwJumpTable
    mov     ecx, 1024
    mov     eax, OFFSET DEFPROC
    rep     stosd
    
    ASSUME  ebx:NOTHING
    ret

ErrorHandler:
    PrintText "Error occured"
    ASSUME ebx:NOTHING
    xor     eax, eax
    ret
__makewin ENDP

; -------------------------------------------------------------------------

__makewin2 PROC USES ebx lpForm:DWORD, dwBackColor:DWORD, hParent:DWORD, lpWndProc:DWORD
    LOCAL hInst:DWORD
    LOCAL wc:WNDCLASSEX
    
    invoke  GetModuleHandle, NULL
    mov     hInst, eax
    
    mov     ebx, lpForm
    ASSUME  ebx:PTR Form
    
    cmp     [ebx].hCursor, 0
    jne     @F
    invoke  LoadCursor, NULL, IDC_ARROW
    mov     [ebx].hCursor, eax

@@: 
    cmp     [ebx].lpszClass, 0
    jne     @F
    mov     [ebx].lpszClass, OFFSET szDefaultClass

@@: 
    cmp     [ebx].lpszCaption, 0
    jne     @F
    mov     [ebx].lpszClass, OFFSET szNull
    
@@: 
    cmp     lpWndProc, 0
    jne     @F
    mov     lpWndProc, OFFSET __wndProc2
    
@@: 
    mov     wc.cbSize,          sizeof WNDCLASSEX
    mov     wc.style,           CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mmov    wc.lpfnWndProc,     lpWndProc
    mov     wc.cbClsExtra,      NULL
    mov     wc.cbWndExtra,      NULL
    mmov    wc.hInstance,       hInst
    mmov    wc.hbrBackground,   dwBackColor
    mov     wc.lpszMenuName,    NULL
    mmov    wc.lpszClassName,   [ebx].lpszClass
    mmov    wc.hIcon,           [ebx].hIcon
    mmov    wc.hCursor,         [ebx].hCursor
    mmov    wc.hIconSm,         [ebx].hIcon

    invoke  RegisterClassEx, ADDR wc
    or      eax, eax
    jz      ErrorHandler

    invoke  CreateWindowEx, WS_EX_MDICHILD,
                            [ebx].lpszClass,
                            [ebx].lpszCaption,
                            MDIS_ALLCHILDSTYLES,
                            [ebx].dwLeft,[ebx].dwTop,[ebx].dwWidth,[ebx].dwHeight,
                            hParent,NULL,
                            hInst,NULL
    or      eax, eax
    jz      ErrorHandler
    
    mov     [ebx].hWnd, eax
    invoke  GetDC, eax
    mov     [ebx].hDC, eax
    
    lea     edi, hWndTable
    inc     WindowsMade
    mov     ecx, WindowsMade
    lea     edi, [edi+ecx*8]
    mmov    DWORD PTR [edi], [ebx].hWnd
    
    mov     [ebx].dwJumpTable, MAlloc(1024*4)
    mov     DWORD PTR [edi+4], eax
    mov     edi, [ebx].dwJumpTable
    mov     ecx, 1024
    mov     eax, OFFSET DEFPROC
    rep     stosd
    
    ASSUME  ebx:NOTHING
    ret

ErrorHandler:
    PrintText "Error occured"
    ASSUME ebx:NOTHING
    xor     eax, eax
    ret
__makewin2 ENDP

; 

UnloadWindow PROC lpForm:DWORD
    mov     ebx, lpForm
    ASSUME  ebx:PTR Form

    mov     eax, [ebx].hWnd
    invoke  DestroyWindow, eax ;[ebx].hWnd
    mov     [ebx].hWnd, 0
    
    MFree   [ebx].dwJumpTable
    
    ASSUME  ebx:NOTHING
    ret    
UnloadWindow ENDP
; 

MoveWin MACRO lpForm, X, Y, W, H
    invoke  SetWindowPos, lpForm.hWnd, 0, X, Y, W, H, SWP_NOZORDER
ENDM

; 

__wndProc PROC USES edi hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    lea     edi, hWndTable
    mov     eax, hWnd
@@: 
    mov     edx, DWORD PTR [edi]
    cmp     edx, eax
    je      @F
    or      edx, edx
    jz      DEFPROC
    add     edi, 8
    jmp     @B
@@: 

    cmp     uMsg, WM_DESTROY
    je      WMDESTROY
    
    mov     edi, DWORD PTR [edi+4]
    mov     eax, uMsg
    
    shl     eax, 2
    add     eax, edi
    push    lParam
    push    wParam
    push    uMsg
    push    hWnd
    call    DWORD PTR [eax]
    
DEFPROC::
    invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
    ret

WMDESTROY:
    mov     eax, lpDestroyCallback
    or      eax, eax
    jz      @F
    call    lpDestroyCallback
@@: 
    invoke  PostQuitMessage,NULL
    ret
__wndProc ENDP

__wndProc2 PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    invoke  DefMDIChildProc, hWnd, uMsg, wParam, lParam
    ret
__wndProc2 ENDP

AddCallback MACRO lpForm, message, label
    LOCAL x
    IFDIFI <message>,<WM_DESTROY>
        IFE (OPATTR message AND 100b)
            IFDIF <message>,<eax>
                mov     eax, message
            ENDIF
            shl     eax, 2
        ELSE
            mov     eax, message*4
        ENDIF
        add     eax, lpForm.dwJumpTable
        mov     edx, label
        mov     DWORD PTR [eax], label
    ELSE
        mov     edx, label
        mov     lpDestroyCallback, edx
    ENDIF
ENDM
