; 

    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
  .nolist
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\debug.inc
  .list

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\debug.lib
    
    include ..\common\common.inc

; 
    CallFunction        PROTO   :DWORD, :DWORD, :DWORD
    SendPluginMessage   PROTO   :DWORD, :DWORD, :DWORD
    LoadLib             PROTO   :DWORD, :DWORD
    StartLib            PROTO   :DWORD
    FreeLib             PROTO   :DWORD
    
    
    .const
        szGetPluginInfo     BYTE    "GetPluginInfo",0
        szCallFunction      BYTE    "CallFunction",0
        szPluginMessage     BYTE    "PluginMessage",0

    .data
        dwLibCount          DWORD   0
        szDLL               BYTE    "*.dll",0
        
    .data?
        dwLib               DWORD   ?

    .code

; 

PlugInfoAddress MACRO index
    mov     edi, index
    imul    edi, SIZEOF PLUGININFO
    add     edi, dwLib
ENDM


start PROC
    LOCAL   msg:MSG
    LOCAL   dwTextBuff:DWORD
    LOCAL   hFind:DWORD
    LOCAL   fdFindFile:WIN32_FIND_DATA

    IF DEBUG
        PrintLine
        PrintText "kernel.exe built 0912h 16MAY04"
        PrintLine
    ENDIF
    
    mov     edi, MAlloc(256*255)
    mov     dwTextBuff, edi
    
    invoke  FindFirstFile, OFFSET szDLL, ADDR fdFindFile
    mov     hFind, eax
    cmp     eax, INVALID_HANDLE_VALUE
    jne     @F
    
    PrintText "No plugins found"
    invoke  ExitProcess, 0
    ret
    
    @@:
    inc     dwLibCount
    invoke  RtlMoveMemory, edi, ADDR fdFindFile.cFileName, 255
    add     edi, 256
    
    invoke  FindNextFile, hFind, ADDR fdFindFile
    or      eax, eax
    jnz     @B
    invoke  FindClose, hFind
    
    IF DEBUG
        PrintDec dwLibCount, "Libraries Found"
        PrintLine
    ENDIF
    
    mov     ecx, dwLibCount
    imul    ecx, SIZEOF PLUGININFO
    mov     dwLib, MAlloc(ecx)
    
    xor     edx, edx
    mov     esi, dwTextBuff
@@: 
    mov     hFind, edx          ; Quicker to use local var than push/pop
    invoke  LoadLib, edx, esi
    mov     edx, hFind          ; "pop" edx
    inc     edx
    add     esi, 256
    cmp     edx, dwLibCount
    jl      @B
    
    MFree   dwTextBuff, (256*255)
    
    xor     edx, edx
@@: 
    push    edx
    IF DEBUG
        PrintDec edx, "Starting Library"
    ENDIF
    invoke  StartLib, edx
    pop     edx
    inc     edx
    cmp     edx, dwLibCount
    jl      @B
    IF DEBUG
        PrintLine
        PrintLine
        PrintText "Starting Loop..."
        PrintLine
    ENDIF
    
; #########################################################################
Loop_Start:
    invoke  GetMessage,ADDR msg,NULL,0,0
    or      eax, eax
    jz      Loop_End
    test    msg.message, PLUGIN_MESSAGES
    jz      End_MessageHandling
    IF DEBUG
        PrintHex msg.message, "and PLUGIN_MESSAGES"
    ENDIF

; ====================================
; This is where messages are dealt with
    mov     eax, msg.message
    mov     esi, dwLib
    xor     edx, edx
    ASSUME  esi:PTR PLUGININFO
    xor     ecx, ecx
    
NextSearch:
    cmp     [esi].dwMessages[ecx*4], eax
    jne     @F
    IF DEBUG
        PrintDec edx, "Library Being Sent Message"
    ENDIF
    pushad
    invoke  SendPluginMessage, edx, eax, msg.lParam
    popad
    IF DEBUG
        PrintDec edx, "Message sent"
        PrintLine
    ENDIF
    @@:
    inc     ecx
    cmp     ecx, 15
    jle     NextSearch
    
    @@:
    inc     edx
    cmp     edx, dwLibCount
    jg      @F
    add     esi, SIZEOF PLUGININFO
    mov     ecx, DWORD PTR [esi].dwStartup
    or      ecx, ecx
    jnz     @B
    
    xor     ecx, ecx
    jmp     NextSearch
    
    @@:
    IF DEBUG
        PrintLine
    ENDIF
    
    ASSUME  esi:NOTHING
    
End_MessageHandling:
; This is where message handling ends
; ====================================

    invoke  TranslateMessage, ADDR msg
    invoke  DispatchMessage,  ADDR msg
    jmp Loop_Start
Loop_End:
; #########################################################################
    
    mov     ebx, dwLibCount
@@:     
    dec     ebx
    IF DEBUG
        PrintDec ebx, "Unloading Library"
    ENDIF
    invoke  FreeLib, ebx
    or      ebx, ebx
    jnz     @B
    
    invoke  ExitProcess, 0
    ret
start ENDP

; 
; ====================================
; 

CallFunction PROC dwIndex:DWORD, dwFunction:DWORD, lpData:DWORD
    PlugInfoAddress dwIndex

    invoke  GetProcAddress, DWORD PTR [edi], OFFSET szCallFunction
    or      eax, eax
    jz      @F
    push    lpData
    push    dwFunction
    call    eax
@@: 
    ret
CallFunction ENDP

; -------------------------------------------------------------------------

SendPluginMessage PROC dwIndex:DWORD, dwMessage:DWORD, lpData:DWORD
    PlugInfoAddress dwIndex
    
    invoke  GetProcAddress, DWORD PTR [edi], OFFSET szPluginMessage
    or      eax, eax
    jz      @F
    push    lpData
    push    dwMessage
    call    eax
@@: 
    ret
SendPluginMessage ENDP

; 

LoadLib PROC dwIndex:DWORD, lpLib:DWORD
    LOCAL   hLib:DWORD
    LOCAL   lpInfo:DWORD
    
    invoke  LoadLibrary, lpLib
    mov     hLib, eax
    invoke  GetProcAddress, hLib, OFFSET szGetPluginInfo
    or      eax, eax
    jz      CannotLoadLib
    push    hLib
    call    DWORD PTR eax
    mov     lpInfo, eax
    
    PlugInfoAddress dwIndex
    
    push    edi
    invoke  RtlMoveMemory, edi, lpInfo, SIZEOF PLUGININFO
    pop     edi
    
    mov     eax, hLib
    mov     DWORD PTR [edi], eax
    ret

    .const
    szCannotLoadLib BYTE "Cannot load library: No GetPluginInfo function is exported",0
    .code
CannotLoadLib:
    invoke  MessageBox, 0, ADDR szCannotLoadLib, lpLib, MB_OK
    ret
LoadLib ENDP

StartLib PROC dwIndex:DWORD
    PlugInfoAddress dwIndex

    ASSUME  edi:PTR PLUGININFO
    mov     eax, [edi].dwStartup
    or      eax, eax
    jnz     @F
    mov     eax, [edi].lpInit
    or      eax, eax
    jz      @F
    call    DWORD PTR eax
@@: 
    ASSUME  edi:NOTHING
    ret
StartLib ENDP

; -------------------------------------------------------------------------

FreeLib PROC dwIndex:DWORD
    LOCAL   hLib:DWORD
    
    PlugInfoAddress dwIndex
    
    mov     eax, DWORD PTR [edi+12]
    or      eax, eax
    jz      @F
    call    DWORD PTR eax
@@: 
    mov     eax, DWORD PTR [edi]
    invoke  FreeLibrary, eax
    ret
FreeLib ENDP


; 
end start
